<script>
    // Library functions
    import { select, scaleTime, zoom } from 'd3';
    import * as d3 from 'd3';
    import { onMount } from 'svelte';

    // Components
    import SubplotGroup from './SubplotGroup.svelte';
    import PlotElement from './PlotElement.svelte';

    // Stores and data manipulation
    import { secondsPerPixel } from './stores/layoutStore.js';
    import { layoutData } from './stores/layoutStore.js';
    import { timeDomain } from './stores/layoutStore.js';
    import { subplotLayouts } from './stores/layoutStore.js';
    import { containerWidth } from './stores/layoutStore.js';

    // Set xScale
    let xScale = scaleTime().domain($timeDomain);
    let xScale_new = scaleTime().domain($timeDomain);

    // React to changes in the margins
    $: leftMargin = $layoutData.global_margins.left;
    $: rightMargin = $layoutData.global_margins.right;
    $: range = [leftMargin, $containerWidth-rightMargin];

    let svgElement; // We will bind this to the SVG element below.
    let timer = 0;  // Timer that is set to 0 during zooming/panning,
                    // so that we can load new data a short time after
                    // the zoom/pan actions stop

    const performZoom = function(e) {
        // Function to execute whenever the user zooms on the SVG
        xScale_new = e.transform.rescaleX(xScale);

        // Reset the timer
        if(timer !== null) {
              clearTimeout(timer);
          }

        // And if there are no new zoom events for xxx ms, it is time for
        //   downloading new data, triggered by setting the
        //   $timeDomain store.
        timer = setTimeout(function() {
            $timeDomain = xScale_new.domain();
        }, 150);

    }

    // Set up vars for min/max zooming and panning
    let curzoom_seconds = ($timeDomain[1] - $timeDomain[0])/1000;
    let minzoom = curzoom_seconds/(250*365.25*86400); // 250 years - perhaps implement overriding these zoom boundaries from the json layout config
    let maxzoom = curzoom_seconds/(20); // 20 seconds

    // Set up the zoom behaviour object
    var zoomObject = zoom()
        .on("zoom", performZoom)
        .scaleExtent([minzoom, maxzoom]);

    // Attaching the zoom behaviour object to the SVG requires it to be mounted in the DOM
    onMount(() => {
        // console.log(svgElement);
        // resize_ob.observe(svgElement);
        select(svgElement).call(zoomObject);
        xScale = scaleTime().domain($timeDomain).range(range);

//         let starlink_t0 = new Date("2022-02-01");
//         let starlink_t1 = new Date("2022-02-04");
//
//         performProgrammaticZoom(
//             zoomTransform(svgElement)
//                 .scale((containerWidth-leftMargin-rightMargin) / (xScale_new(starlink_t1) - xScale_new(starlink_t0)))
//                 .translate(-1*(xScale_new(starlink_t0)-leftMargin), 0));


    });

    // Recompute the xScale every time the left/right margins or window width change
    $: xScale = xScale.range(range);
    $: xScale_new = xScale_new.range(range);
    $: secondsPerPixel.set(1/(xScale_new(1000) - xScale_new(0)));

    select(svgElement).call(zoomObject);


//     let test_timer = 0; // Timer to track whether zoom actions have stopped
//     const performProgrammaticZoom = function(newzoom) {
//         // Reset the timer
//         // if(timer !== null) {
//         //       clearTimeout(timer);
//         //   }
//
//         // And if there are no new zoom events for xxx ms, it is time for
//         //   looking into downloading new data, triggered by setting the
//         //   $timeDomain store.
//         test_timer = setTimeout(function() {
//             console.log("test")
//             select(svgElement).transition().duration(1250).call(zoomObject.transform, newzoom);
//
//             // .scale(width / (x(d1) - x(d0)))
//             // .translate(-x(d0), 0)
//         }, 2000);
//     }


</script>


<svg height="100%" width="100%" bind:this={svgElement} on:resize={(e) => {console.log("Resize: ", e)}}>
<!--  Filter definitions -->
    <defs>
        <!-- Blurred white outline for readability of label text -->
        <filter id="whiteOutlineEffect" color-interpolation-filters="sRGB">
          <feMorphology in="SourceAlpha" result="MORPH" operator="dilate" radius="0.75"/>
          <feColorMatrix in="MORPH" result="WHITENED" type="matrix" values="-1 0 0 0 1, 0 -1 0 0 1, 0 0 -1 0 1, 0 0 0 1 0"/>
          <feGaussianBlur in="WHITENED" result="BLURRED" stdDeviation="0.5" />
          <feMerge>
            <feMergeNode in="BLURRED"/>
            <feMergeNode in="SourceGraphic"/>
          </feMerge>
        </filter>
    </defs>

<!-- Loop over subplots -->
    {#each $subplotLayouts as subplot (subplot.id)}
        {#if subplot['visible']}
            <SubplotGroup subplotLayout={subplot} xScale={xScale_new}>
                {#each subplot.plot_elements as plotElement}
                    <PlotElement {plotElement} {subplot} xScale={xScale_new}/>
                {/each}
            </SubplotGroup>
        {/if}
    {/each}
</svg>

<style>

</style>
